Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12858)
@@ -51,57 +51,56 @@
     [HttpPost]
     public DT.TaskPage GetTasksByJobId(Guid id, int page, int size, IEnumerable<string> states) {
-      using (var pm = PersistenceManager) {
-        var dimJobDao = pm.DimJobDao;
-        var dimClientDao = pm.DimClientDao;
-        var factTaskDao = pm.FactTaskDao;
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var dimClientDao = pm.DimClientDao;
+      var factTaskDao = pm.FactTaskDao;
 
-        DA.DimJob job = pm.UseTransaction(() => dimJobDao.GetById(id));
-        if (job == null) {
-          throw new ArgumentException("invalid job id");
-        }
-        if (job.UserId != UserManager.CurrentUserId) {
-          RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
-        }
+      DA.DimJob job = pm.UseTransaction(() => dimJobDao.GetById(id));
+      if (job == null) {
+        throw new ArgumentException("invalid job id");
+      }
+      if (job.UserId != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
 
-        return pm.UseTransaction(() => {
-          var tasks = factTaskDao.GetByJobId(id).Where(x => states.Contains(x.TaskState.ToString()));
-          return new DT.TaskPage {
-            TotalTasks = tasks.Count(),
-            Tasks = (from factTask in tasks
-                     join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
-                     join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
-                       dimClient.Id into taskClientJoin
-                     from a in taskClientJoin.DefaultIfEmpty()
-                     let startTime = factTask.StartTime ?? DateTime.Now
-                     let endTime = factTask.EndTime ?? DateTime.Now
-                     select new DT.Task {
-                       Id = factTask.TaskId,
-                       JobId = factTask.JobId,
-                       JobName = dimJob.JobName,
-                       TotalTime = (long)(endTime - startTime).TotalSeconds,
-                       CalculatingTime = factTask.CalculatingTime,
-                       WaitingTime = factTask.WaitingTime,
-                       TransferTime = factTask.TransferTime,
-                       InitialWaitingTime = factTask.InitialWaitingTime,
-                       NumCalculationRuns = factTask.NumCalculationRuns,
-                       NumRetries = factTask.NumRetries,
-                       CoresRequired = factTask.CoresRequired,
-                       MemoryRequired = factTask.MemoryRequired,
-                       Priority = factTask.Priority,
-                       State = factTask.TaskState.ToString(),
-                       LastClientId = factTask.LastClientId,
-                       LastClientName = a != null ? a.Name : string.Empty,
-                       UserId = dimJob.UserId,
-                       UserName = dimJob.UserName,
-                       StartTime = factTask.StartTime,
-                       EndTime = factTask.EndTime,
-                       Exception = factTask.Exception
-                     })
-              .Skip((page - 1) * size)
-              .Take(size)
-              .ToList()
-          };
-        });
-      }
+      return pm.UseTransaction(() => {
+        var tasks = factTaskDao.GetByJobId(id).Where(x => states.Contains(x.TaskState.ToString()));
+        return new DT.TaskPage {
+          TotalTasks = tasks.Count(),
+          Tasks = (from factTask in tasks
+                   join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                   join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                     dimClient.Id into taskClientJoin
+                   from a in taskClientJoin.DefaultIfEmpty()
+                   let startTime = factTask.StartTime ?? DateTime.Now
+                   let endTime = factTask.EndTime ?? DateTime.Now
+                   select new DT.Task {
+                     Id = factTask.TaskId,
+                     JobId = factTask.JobId,
+                     JobName = dimJob.JobName,
+                     TotalTime = (long)(endTime - startTime).TotalSeconds,
+                     CalculatingTime = factTask.CalculatingTime,
+                     WaitingTime = factTask.WaitingTime,
+                     TransferTime = factTask.TransferTime,
+                     InitialWaitingTime = factTask.InitialWaitingTime,
+                     NumCalculationRuns = factTask.NumCalculationRuns,
+                     NumRetries = factTask.NumRetries,
+                     CoresRequired = factTask.CoresRequired,
+                     MemoryRequired = factTask.MemoryRequired,
+                     Priority = factTask.Priority,
+                     State = factTask.TaskState.ToString(),
+                     LastClientId = factTask.LastClientId,
+                     LastClientName = a != null ? a.Name : string.Empty,
+                     UserId = dimJob.UserId,
+                     UserName = dimJob.UserName,
+                     StartTime = factTask.StartTime,
+                     EndTime = factTask.EndTime,
+                     Exception = factTask.Exception
+                   })
+            .Skip((page - 1) * size)
+            .Take(size)
+            .ToList()
+        };
+      });
     }
 
@@ -109,72 +108,70 @@
     public DT.TaskPage GetTasksByClientId(Guid id, int page, int size, IEnumerable<string> states, Guid userId = default(Guid)) {
       bool isAdministrator = User.IsInRole(HiveRoles.Administrator);
-      using (var pm = PersistenceManager) {
-        var dimJobDao = pm.DimJobDao;
-        var dimClientDao = pm.DimClientDao;
-        var factTaskDao = pm.FactTaskDao;
-        return pm.UseTransaction(() => {
-          var tasks = factTaskDao.GetByClientId(id).Where(x => states.Contains(x.TaskState.ToString()));
-          if (userId != Guid.Empty) {
-            tasks = tasks.Where(x => x.DimJob.UserId == userId);
-          }
-          return new DT.TaskPage {
-            TotalTasks = tasks.Count(),
-            Tasks = (from factTask in tasks
-                     join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
-                     join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
-                       dimClient.Id into taskClientJoin
-                     from a in taskClientJoin.DefaultIfEmpty()
-                     let startTime = factTask.StartTime ?? DateTime.Now
-                     let endTime = factTask.EndTime ?? DateTime.Now
-                     select new DT.Task {
-                       Id = isAdministrator ? factTask.TaskId : default(Guid),
-                       JobId = isAdministrator ? factTask.JobId : default(Guid),
-                       JobName = isAdministrator ? dimJob.JobName : string.Empty,
-                       TotalTime = (long)(endTime - startTime).TotalSeconds,
-                       CalculatingTime = factTask.CalculatingTime,
-                       WaitingTime = factTask.WaitingTime,
-                       TransferTime = factTask.TransferTime,
-                       InitialWaitingTime = factTask.InitialWaitingTime,
-                       NumCalculationRuns = factTask.NumCalculationRuns,
-                       NumRetries = factTask.NumRetries,
-                       CoresRequired = factTask.CoresRequired,
-                       MemoryRequired = factTask.MemoryRequired,
-                       Priority = factTask.Priority,
-                       State = factTask.TaskState.ToString(),
-                       LastClientId = factTask.LastClientId,
-                       LastClientName = a != null ? a.Name : string.Empty,
-                       UserId = isAdministrator ? dimJob.UserId : default(Guid),
-                       UserName = isAdministrator ? dimJob.UserName : string.Empty,
-                       StartTime = factTask.StartTime,
-                       EndTime = factTask.EndTime,
-                       Exception = isAdministrator ? factTask.Exception : string.Empty
-                     })
-                  .OrderByDescending(x => x.EndTime ?? DateTime.MaxValue)
-                  .Skip((page - 1) * size)
-                  .Take(size)
-                  .ToList()
-          };
-        });
-      }
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var dimClientDao = pm.DimClientDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var tasks = factTaskDao.GetByClientId(id).Where(x => states.Contains(x.TaskState.ToString()));
+        if (userId != Guid.Empty) {
+          tasks = tasks.Where(x => x.DimJob.UserId == userId);
+        }
+        return new DT.TaskPage {
+          TotalTasks = tasks.Count(),
+          Tasks = (from factTask in tasks
+                   join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                   join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                     dimClient.Id into taskClientJoin
+                   from a in taskClientJoin.DefaultIfEmpty()
+                   let startTime = factTask.StartTime ?? DateTime.Now
+                   let endTime = factTask.EndTime ?? DateTime.Now
+                   select new DT.Task {
+                     Id = isAdministrator ? factTask.TaskId : default(Guid),
+                     JobId = isAdministrator ? factTask.JobId : default(Guid),
+                     JobName = isAdministrator ? dimJob.JobName : string.Empty,
+                     TotalTime = (long)(endTime - startTime).TotalSeconds,
+                     CalculatingTime = factTask.CalculatingTime,
+                     WaitingTime = factTask.WaitingTime,
+                     TransferTime = factTask.TransferTime,
+                     InitialWaitingTime = factTask.InitialWaitingTime,
+                     NumCalculationRuns = factTask.NumCalculationRuns,
+                     NumRetries = factTask.NumRetries,
+                     CoresRequired = factTask.CoresRequired,
+                     MemoryRequired = factTask.MemoryRequired,
+                     Priority = factTask.Priority,
+                     State = factTask.TaskState.ToString(),
+                     LastClientId = factTask.LastClientId,
+                     LastClientName = a != null ? a.Name : string.Empty,
+                     UserId = isAdministrator ? dimJob.UserId : default(Guid),
+                     UserName = isAdministrator ? dimJob.UserName : string.Empty,
+                     StartTime = factTask.StartTime,
+                     EndTime = factTask.EndTime,
+                     Exception = isAdministrator ? factTask.Exception : string.Empty
+                   })
+                .OrderByDescending(x => x.EndTime ?? DateTime.MaxValue)
+                .Skip((page - 1) * size)
+                .Take(size)
+                .ToList()
+        };
+      });
     }
 
     public HttpResponseMessage GetTaskDataById(Guid id) {
-      using (var pm = PersistenceManager) {
-        var taskDataDao = pm.TaskDataDao;
-        return pm.UseTransaction(() => {
-          var taskData = taskDataDao.GetById(id);
-          if (taskData == null)
-            return new HttpResponseMessage(HttpStatusCode.NotFound);
-          HttpResponseMessage result = new HttpResponseMessage(HttpStatusCode.OK);
-          var stream = new MemoryStream(taskData.Data);
-          result.Content = new StreamContent(stream);
-          result.Content.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");
-          result.Content.Headers.ContentDisposition =
-            new ContentDispositionHeaderValue("attachment") {
-              FileName = string.Format("{0}.hl", id)
-            };
-          return result;
-        });
-      }
+      var pm = PersistenceManager;
+      var taskDataDao = pm.TaskDataDao;
+      return pm.UseTransaction(() => {
+        var taskData = taskDataDao.GetById(id);
+        if (taskData == null)
+          return new HttpResponseMessage(HttpStatusCode.NotFound);
+        HttpResponseMessage result = new HttpResponseMessage(HttpStatusCode.OK);
+        var stream = new MemoryStream(taskData.Data);
+        result.Content = new StreamContent(stream);
+        result.Content.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");
+        result.Content.Headers.ContentDisposition =
+          new ContentDispositionHeaderValue("attachment") {
+            FileName = string.Format("{0}.hl", id)
+          };
+        return result;
+      });
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12858)
@@ -37,36 +37,34 @@
 
     public IEnumerable<DT.User> GetUsers() {
-      using (var pm = PersistenceManager) {
-        var dimUserDao = pm.DimUserDao;
-        return pm.UseTransaction(() => {
-          return dimUserDao.GetAll().Select(x => new DT.User {
-            Id = x.UserId,
-            Name = x.Name
-          }).ToList();
-        });
-      }
+      var pm = PersistenceManager;
+      var dimUserDao = pm.DimUserDao;
+      return pm.UseTransaction(() => {
+        return dimUserDao.GetAll().Select(x => new DT.User {
+          Id = x.UserId,
+          Name = x.Name
+        }).ToList();
+      });
     }
 
     public DT.UserDetails GetUser(Guid id) {
-      using (var pm = PersistenceManager) {
-        var dimUserDao = pm.DimUserDao;
-        var factTaskDao = pm.FactTaskDao;
-        return pm.UseTransaction(() => {
-          var user = dimUserDao.GetById(id);
-          if (user != null) {
-            return new DT.UserDetails {
-              Id = user.UserId,
-              Name = user.Name,
-              TasksStates = factTaskDao.GetByUserId(id)
-                            .GroupBy(x => x.TaskState)
-                            .Select(x => new DT.TaskStateCount {
-                              State = x.Key.ToString(),
-                              Count = x.Count()
-                            }).ToList()
-            };
-          }
-          return null;
-        });
-      }
+      var pm = PersistenceManager;
+      var dimUserDao = pm.DimUserDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var user = dimUserDao.GetById(id);
+        if (user != null) {
+          return new DT.UserDetails {
+            Id = user.UserId,
+            Name = user.Name,
+            TasksStates = factTaskDao.GetByUserId(id)
+                          .GroupBy(x => x.TaskState)
+                          .Select(x => new DT.TaskStateCount {
+                            State = x.Key.ToString(),
+                            Count = x.Count()
+                          }).ToList()
+          };
+        }
+        return null;
+      });
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApi/DataController.cs	(revision 12858)
@@ -99,53 +99,52 @@
 
     public DT.Status GetStatus() {
-      using (var pm = PersistenceManager) {
-        var slaveDao = pm.SlaveDao;
-        var onlineSlaves = pm.UseTransaction(() => slaveDao.GetOnlineSlaves().ToList());
-        var activeSlaves = onlineSlaves.Where(s => s.IsAllowedToCalculate).ToList();
-        var calculatingSlaves = activeSlaves.Where(s => s.SlaveState == SlaveState.Calculating).ToList();
-        int totalCores = onlineSlaves.Sum(s => s.Cores ?? 0);
-        int totalMemory = onlineSlaves.Sum(s => s.Memory ?? 0);
-        return new DT.Status {
-          CoreStatus = new DT.CoreStatus {
-            TotalCores = totalCores,
-            UsedCores = totalCores - onlineSlaves.Sum(s => s.FreeCores ?? 0),
-            ActiveCores = activeSlaves.Sum(s => s.Cores ?? 0),
-            CalculatingCores = calculatingSlaves.Sum(s => s.Cores ?? 0) - calculatingSlaves.Sum(s => s.FreeCores ?? 0)
+      var pm = PersistenceManager;
+      var slaveDao = pm.SlaveDao;
+      var onlineSlaves = pm.UseTransaction(() => slaveDao.GetOnlineSlaves().ToList());
+      var activeSlaves = onlineSlaves.Where(s => s.IsAllowedToCalculate).ToList();
+      var calculatingSlaves = activeSlaves.Where(s => s.SlaveState == SlaveState.Calculating).ToList();
+      int totalCores = onlineSlaves.Sum(s => s.Cores ?? 0);
+      int totalMemory = onlineSlaves.Sum(s => s.Memory ?? 0);
+      return new DT.Status {
+        CoreStatus = new DT.CoreStatus {
+          TotalCores = totalCores,
+          UsedCores = totalCores - onlineSlaves.Sum(s => s.FreeCores ?? 0),
+          ActiveCores = activeSlaves.Sum(s => s.Cores ?? 0),
+          CalculatingCores = calculatingSlaves.Sum(s => s.Cores ?? 0) - calculatingSlaves.Sum(s => s.FreeCores ?? 0)
+        },
+        CpuUtilizationStatus = new DT.CpuUtilizationStatus {
+          TotalCpuUtilization = onlineSlaves.Any()
+                                ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2)
+                                : 0.0,
+          ActiveCpuUtilization = activeSlaves.Any()
+                                 ? Math.Round(activeSlaves.Average(s => s.CpuUtilization), 2)
+                                 : 0.0,
+          CalculatingCpuUtilization = calculatingSlaves.Any()
+                                      ? Math.Round(calculatingSlaves.Average(s => s.CpuUtilization), 2)
+                                      : 0.0
+        },
+        MemoryStatus = new DT.MemoryStatus {
+          TotalMemory = totalMemory,
+          UsedMemory = totalMemory - onlineSlaves.Sum(s => s.FreeMemory ?? 0),
+          ActiveMemory = activeSlaves.Sum(s => s.Memory ?? 0),
+          CalculatingMemory = calculatingSlaves.Sum(s => s.Memory ?? 0) - calculatingSlaves.Sum(s => s.FreeMemory ?? 0)
+        },
+        TimeStatus = GetTimeStatus(pm),
+        TasksStatus = GetTaskStatus(pm),
+        SlavesStatus = onlineSlaves.Select(x => new DT.SlaveStatus {
+          Slave = new DT.Slave {
+            Id = x.ResourceId.ToString(),
+            Name = x.Name
           },
-          CpuUtilizationStatus = new DT.CpuUtilizationStatus {
-            TotalCpuUtilization = onlineSlaves.Any()
-                                  ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2)
-                                  : 0.0,
-            ActiveCpuUtilization = activeSlaves.Any()
-                                   ? Math.Round(activeSlaves.Average(s => s.CpuUtilization), 2)
-                                   : 0.0,
-            CalculatingCpuUtilization = calculatingSlaves.Any()
-                                        ? Math.Round(calculatingSlaves.Average(s => s.CpuUtilization), 2)
-                                        : 0.0
-          },
-          MemoryStatus = new DT.MemoryStatus {
-            TotalMemory = totalMemory,
-            UsedMemory = totalMemory - onlineSlaves.Sum(s => s.FreeMemory ?? 0),
-            ActiveMemory = activeSlaves.Sum(s => s.Memory ?? 0),
-            CalculatingMemory = calculatingSlaves.Sum(s => s.Memory ?? 0) - calculatingSlaves.Sum(s => s.FreeMemory ?? 0)
-          },
-          TimeStatus = GetTimeStatus(pm),
-          TasksStatus = GetTaskStatus(pm),
-          SlavesStatus = onlineSlaves.Select(x => new DT.SlaveStatus {
-            Slave = new DT.Slave {
-              Id = x.ResourceId.ToString(),
-              Name = x.Name
-            },
-            CpuUtilization = x.CpuUtilization,
-            Cores = x.Cores ?? 0,
-            FreeCores = x.FreeCores ?? 0,
-            Memory = x.Memory ?? 0,
-            FreeMemory = x.FreeMemory ?? 0,
-            IsAllowedToCalculate = x.IsAllowedToCalculate,
-            State = x.SlaveState.ToString()
-          }).OrderBy(x => x.Slave.Name),
-          Timestamp = JavascriptUtils.ToTimestamp(DateTime.Now)
-        };
-      }
+          CpuUtilization = x.CpuUtilization,
+          Cores = x.Cores ?? 0,
+          FreeCores = x.FreeCores ?? 0,
+          Memory = x.Memory ?? 0,
+          FreeMemory = x.FreeMemory ?? 0,
+          IsAllowedToCalculate = x.IsAllowedToCalculate,
+          State = x.SlaveState.ToString()
+        }).OrderBy(x => x.Slave.Name),
+        Timestamp = JavascriptUtils.ToTimestamp(DateTime.Now)
+      };
     }
 
@@ -158,56 +157,55 @@
         increment += 5;
       }
-      using (var pm = PersistenceManager) {
-        var factClientInfoDao = pm.FactClientInfoDao;
-        var clientInfos = pm.UseTransaction(() => {
-          return factClientInfoDao.GetAll()
-            .Where(s => s.Time >= start
-                        && s.Time <= end
-                        && s.SlaveState != SlaveState.Offline)
-            .OrderBy(s => s.Time)
-            .GroupBy(s => s.Time)
-            .Select(x => new {
-              Timestamp = x.Key,
-              TotalCores = x.Sum(y => y.NumTotalCores),
-              UsedCores = x.Sum(y => y.NumUsedCores),
-              TotalMemory = x.Sum(y => y.TotalMemory),
-              UsedMemory = x.Sum(y => y.UsedMemory),
-              CpuUtilization = x.Where(y => y.IsAllowedToCalculate).Average(y => y.CpuUtilization)
-            })
-            .ToList();
-        });
-        var statusList = new List<DT.Status>();
-        var e = clientInfos.GetEnumerator();
-        do {
-          var status = new DT.Status {
-            CoreStatus = new DT.CoreStatus(),
-            CpuUtilizationStatus = new DT.CpuUtilizationStatus(),
-            MemoryStatus = new DT.MemoryStatus()
-          };
-          int i = 0;
-          DateTime lastTimestamp = DateTime.Now;
-          while (e.MoveNext()) {
-            var clientInfo = e.Current;
-            status.CoreStatus.TotalCores += clientInfo.TotalCores;
-            status.CoreStatus.UsedCores += clientInfo.UsedCores;
-            status.MemoryStatus.TotalMemory += clientInfo.TotalMemory;
-            status.MemoryStatus.UsedMemory += clientInfo.UsedMemory;
-            status.CpuUtilizationStatus.TotalCpuUtilization += clientInfo.CpuUtilization;
-            lastTimestamp = clientInfo.Timestamp;
-            i++;
-            if (i >= increment)
-              break;
-          }
-          if (i <= 0) continue;
-          status.Timestamp = JavascriptUtils.ToTimestamp(lastTimestamp);
-          status.CoreStatus.TotalCores /= i;
-          status.CoreStatus.UsedCores /= i;
-          status.MemoryStatus.TotalMemory /= i;
-          status.MemoryStatus.UsedMemory /= i;
-          status.CpuUtilizationStatus.TotalCpuUtilization /= i;
-          statusList.Add(status);
-        } while (e.Current != null);
-        return statusList;
-      }
+      var pm = PersistenceManager;
+      var factClientInfoDao = pm.FactClientInfoDao;
+      var clientInfos = pm.UseTransaction(() => {
+        return factClientInfoDao.GetAll()
+          .Where(s => s.Time >= start
+                      && s.Time <= end
+                      && s.SlaveState != SlaveState.Offline)
+          .OrderBy(s => s.Time)
+          .GroupBy(s => s.Time)
+          .Select(x => new {
+            Timestamp = x.Key,
+            TotalCores = x.Sum(y => y.NumTotalCores),
+            UsedCores = x.Sum(y => y.NumUsedCores),
+            TotalMemory = x.Sum(y => y.TotalMemory),
+            UsedMemory = x.Sum(y => y.UsedMemory),
+            CpuUtilization = x.Where(y => y.IsAllowedToCalculate).Average(y => y.CpuUtilization)
+          })
+          .ToList();
+      });
+      var statusList = new List<DT.Status>();
+      var e = clientInfos.GetEnumerator();
+      do {
+        var status = new DT.Status {
+          CoreStatus = new DT.CoreStatus(),
+          CpuUtilizationStatus = new DT.CpuUtilizationStatus(),
+          MemoryStatus = new DT.MemoryStatus()
+        };
+        int i = 0;
+        DateTime lastTimestamp = DateTime.Now;
+        while (e.MoveNext()) {
+          var clientInfo = e.Current;
+          status.CoreStatus.TotalCores += clientInfo.TotalCores;
+          status.CoreStatus.UsedCores += clientInfo.UsedCores;
+          status.MemoryStatus.TotalMemory += clientInfo.TotalMemory;
+          status.MemoryStatus.UsedMemory += clientInfo.UsedMemory;
+          status.CpuUtilizationStatus.TotalCpuUtilization += clientInfo.CpuUtilization;
+          lastTimestamp = clientInfo.Timestamp;
+          i++;
+          if (i >= increment)
+            break;
+        }
+        if (i <= 0) continue;
+        status.Timestamp = JavascriptUtils.ToTimestamp(lastTimestamp);
+        status.CoreStatus.TotalCores /= i;
+        status.CoreStatus.UsedCores /= i;
+        status.MemoryStatus.TotalMemory /= i;
+        status.MemoryStatus.UsedMemory /= i;
+        status.CpuUtilizationStatus.TotalCpuUtilization /= i;
+        statusList.Add(status);
+      } while (e.Current != null);
+      return statusList;
     }
 
